c |$Id: gauss.f,v 1.1.1.1 2022/12/27 22:03:00 pm Exp $               |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://173.255.241.228                | 
c | PROGRAM NAME: agc.f                                        |
c | DIRECTORY: bsu-3.0.3/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2021 Paul Michaels                          |
c |  <paulmichaels@boisestate.edu>                             |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c --------------------------------------------------------------
c | AUTHOR: P. MICHAELS                      DATE: 6 Nov 94    |
c |                                                            |
c | gauss.for Gauss Jordan solution of simultaneous equations  |
c |    A=augmented matrix                                      |
c |    x=solution vector                                       |
c |                                                            |
c --------------------------------------------------------------
c
      subroutine gauss(a,x)
      real*4            a(5,6), x(5), ck(5)
      integer*4         loc(5)
c
      eps=1.e-40
      io11=11
      n=5
      np=n+1
      do 1 i=1,n
    1 ck(i)=0.
      do 100 i=1,n
      ip=i+1
c
c...find max element in ith col
      amax=0.
      do 2 k=1,n
      if(amax-abs(a(k,i))) 3,2,2
c
c...is new max in row previously used as pivot?
    3 if(ck(k)) 4,4,2
    4 loc(i)=k
      amax=abs(a(k,i))
    2 continue
      if(abs(amax).le.eps) go to 99
c
c...max element in ith col is a(l,i)
    5 l=loc(i)
      ck(l)=1.
c
c...perform elimination, l is pivot row, a(l,i) is pivot element
      do 50 j=1,n
      if(l-j) 6,50,6
    6 f=-a(j,i)/a(l,i)
      do 40 k=ip,np
   40 a(j,k)=a(j,k)+f*a(l,k)
   50 continue
  100 continue
      do 200 i=1,n
      l=loc(i)
  200 x(i)=a(l,n+1)/a(l,i)
      return
   99 write(io11,999)
  999 format(5x,'NO SOLUTION')
      return
      end
